-- LargeCastBar for RIFT by Vritra

-- local Valiable
local LastUpdate, SetSizeDone, TBarEnable, FBarEnable, GBarEnable, PBarEnable

-- Define
local REFRESH = .06

-- Saved valiable
L_CB = {}

table.insert(Event.Addon.SavedVariables.Load.End, {function(addonName)
	if addonName == "LargeCastBar" then
		LastUpdate = Inspect.Time.Real() + 1

		TBarEnable = L_CB.TargetBarEnable
		if TBarEnable == nil then TBarEnable = true end
		if TBarEnable then
			LTCB = {}
			LTCB.parent = UI.Native.PortraitTarget
			LTCB.h = L_CB.TargetBarHeight
			LTCB.w = L_CB.TargetBarWidth
			LTCB.x = L_CB.TargetBarX
			LTCB.y = L_CB.TargetBarY
			LTCB.a = L_CB.TargetBarAlpha
			LTCB.title = "LCB Target Castbar"
			LTCB.lookup = "player.target"
		else
			LTCB = nil
		end

		FBarEnable = L_CB.FocusBarEnable
		if FBarEnable == nil then FBarEnable = true end
		if FBarEnable then
			LFCB = {}
			LFCB.parent = UI.Native.PortraitFocus
			LFCB.h = L_CB.FocusBarHeight
			LFCB.w = L_CB.FocusBarWidth
			LFCB.x = L_CB.FocusBarX
			LFCB.y = L_CB.FocusBarY
			LFCB.a = L_CB.FocusBarAlpha
			LFCB.title = "LCB Focus Castbar"
			LFCB.lookup = "focus"
		else
			LFCB = nil
		end

		GBarEnable = L_CB.TTBarEnable
		if GBarEnable == nil then GBarEnable = false end
		if GBarEnable then
			LGCB = {}
			LGCB.parent = UI.Native.PortraitTargetTarget
			LGCB.h = L_CB.TTBarHeight
			LGCB.w = L_CB.TTBarWidth
			LGCB.x = L_CB.TTBarX
			LGCB.y = L_CB.TTBarY
			LGCB.a = L_CB.TTBarAlpha
			LGCB.title = "LCB Target Target"
			LGCB.lookup = "player.target.target"
		else
			LGCB = nil
		end

		PBarEnable = L_CB.PlayerBarEnable
		if PBarEnable == nil then PBarEnable = false end
		if PBarEnable then
			LPCB = {}
			LPCB.parent = UI.Native.Castbar
			LPCB.h = L_CB.PlayerBarHeight or LPCB.parent:GetHeight()
			LPCB.w = L_CB.PlayerBarWidth or LPCB.parent:GetWidth()
			LPCB.x = L_CB.PlayerBarX or LPCB.parent:GetLeft()
			LPCB.y = L_CB.PlayerBarY or LPCB.parent:GetTop()
			LPCB.a = L_CB.PlayerBarAlpha
			LPCB.title = "LCB Castbar"
			LPCB.lookup = "player"
		else
			LPCB = nil
		end
	end
end, "LargeCastBar", "LoadValue"})

function Pr(str, console, color)
	local TAG = "<font color='#55ff00'>L</font>"
	TAG = TAG.."<font color='#7fff55'>C</font>"
	TAG = TAG.."<font color='#aaffbb'>B</font>"
	TAG = TAG.."<font color='#8cd0ea'>;</font>"
	str = str or ""
	console = console or "general"
	color = color or "#eaeaea"
	str = TAG.." <font color='"..color.."'>"..str.."</font>"
	Command.Console.Display(console, true, str, true)
end

local function SetSize(CB)
	if not CB then return end

	CB.h = CB.h or CB.parent:GetHeight()*.12
	CB.w = CB.w or CB.parent:GetWidth()*.65
	CB.x = CB.x or CB.parent:GetLeft()-CB.parent:GetWidth()*.04
	CB.y = CB.y or CB.parent:GetTop()+CB.parent:GetHeight()*.06
	CB.a = CB.a or 1

	CB.h = math.ceil(CB.h)
	CB.w = math.ceil(CB.w)
	CB.x = math.ceil(CB.x)
	CB.y = math.ceil(CB.y)

	CB.Frame1:SetHeight(CB.h)
	CB.Frame1:SetWidth(CB.w)
	CB.Frame1:SetPoint(0,0, UIParent, 0,0, CB.x, CB.y)
	CB.Frame1:SetAlpha(CB.a)

	CB.Mask1:SetWidth(0)
	CB.FrashTexture1:SetWidth(math.ceil(CB.h*.8))

	local f = math.ceil(CB.h*.65)
	CB.AbiTextShadow1:SetFontSize(f)
	CB.AbiTextShadow2:SetFontSize(f)
	CB.AbiText1:SetFontSize(f)
end

table.insert(Event.Addon.Load.End, {function(addon)
	if addon == "LargeCastBar" then
		L_CB.Context = UI.CreateContext("LargeCastBar")

		-- sub
		local function CreateUI(CB)
			if not CB then return end
			CB.Frame1 = UI.CreateFrame("Frame", "Frame1", L_CB.Context)
			CB.Frame1:SetVisible(false)
			CB.lock = true

			function CB.Frame1.Event:LeftDown()
				if CB.lock == false then
					CB.Frame1.mouseDown = true
					local mouse = Inspect.Mouse()
					CB.Frame1.startX = CB.Frame1:GetLeft()
					CB.Frame1.startY = CB.Frame1:GetTop()
					CB.Frame1.mouseStartX = mouse.x
					CB.Frame1.mouseStartY = mouse.y
				end
			end

			function CB.Frame1.Event:MouseMove()
				if CB.Frame1.mouseDown and CB.lock == false then
					local mouse = Inspect.Mouse()
					CB.x = mouse.x - CB.Frame1.mouseStartX + CB.Frame1.startX
					CB.y = mouse.y - CB.Frame1.mouseStartY + CB.Frame1.startY
					CB.Frame1:SetPoint(0,0, UIParent, 0,0, CB.x, CB.y)
				end
			end

			function CB.Frame1.Event:LeftUp()
				CB.Frame1.mouseDown = false
			end

			function CB.Frame1.Event:RightClick()
				CB.lock = true
				CB.Frame1:SetVisible(false)
			end

			CB.BGTexture1 = UI.CreateFrame("Texture", "BGTexture1", CB.Frame1)
			CB.BGTexture1:SetAllPoints(CB.Frame1)
			CB.BGTexture1:SetTexture("LargeCastBar", "BG.png")

			CB.Mask1 = UI.CreateFrame("Texture", "Mask1", CB.Frame1)
			CB.Mask1:SetPoint(1,0, CB.Frame1, 1,0)
			CB.Mask1:SetPoint(1,1, CB.Frame1, 1,1)
			CB.Mask1:SetLayer(1)
			CB.Mask1:SetTexture("LargeCastBar", "Mask.png")

			CB.BarColorFrame1 = UI.CreateFrame("Frame", "BarColorFrame1", CB.Frame1)
			CB.BarColorFrame1:SetPoint(0,0, CB.Frame1, 0,.1)
			CB.BarColorFrame1:SetPoint(1,1, CB.Mask1, 0,.9)
			CB.BarColorFrame1:SetBackgroundColor(0,.6,.9,.5)
			CB.BarColorFrame1:SetLayer(2)

			CB.LeftCapTexture1 = UI.CreateFrame("Texture", "LeftCapTexture1", CB.Frame1)
			CB.LeftCapTexture1:SetPoint(1,0, CB.Frame1, 0,0)
			CB.LeftCapTexture1:SetPoint(1,1, CB.Frame1, 0,1)
			CB.LeftCapTexture1:SetWidth(2)
			CB.LeftCapTexture1:SetLayer(3)
			CB.LeftCapTexture1:SetTexture("LargeCastBar", "LeftCap.png")

			CB.RightCapTexture1 = UI.CreateFrame("Texture", "RightCapTexture1", CB.Frame1)
			CB.RightCapTexture1:SetPoint(0,0, CB.Frame1, 1,0)
			CB.RightCapTexture1:SetPoint(0,1, CB.Frame1, 1,1)
			CB.RightCapTexture1:SetWidth(2)
			CB.RightCapTexture1:SetLayer(3)
			CB.RightCapTexture1:SetTexture("LargeCastBar", "RightCap.png")

			CB.FrashTexture1 = UI.CreateFrame("Texture", "FrashTexture1", CB.Mask1)
			CB.FrashTexture1:SetPoint(1,0, CB.Mask1, 0,.1)
			CB.FrashTexture1:SetPoint(1,1, CB.Mask1, 0,.9)
			CB.FrashTexture1:SetLayer(4)
			CB.FrashTexture1:SetTexture("LargeCastBar", "Frash.png")

			CB.AbiTextShadow1 = UI.CreateFrame("Text", "AbiTextShadow1", CB.Frame1)
			CB.AbiTextShadow1:SetLayer(5)
			CB.AbiTextShadow1:SetPoint(.5,.5, CB.Frame1, .5,.5, 1,1)
			CB.AbiTextShadow1:SetFontColor(0,0,0)

			CB.AbiTextShadow2 = UI.CreateFrame("Text", "AbiTextShadow2", CB.Frame1)
			CB.AbiTextShadow2:SetLayer(5)
			CB.AbiTextShadow2:SetPoint(.5,.5, CB.Frame1, .5,.5, -1,-1)
			CB.AbiTextShadow2:SetFontColor(0,0,0)
			CB.AbiTextShadow2:SetAlpha(.8)

			CB.AbiText1 = UI.CreateFrame("Text", "AbiText1", CB.Frame1)
			CB.AbiText1:SetPoint(.5,.5, CB.Frame1, .5,.5)
			CB.AbiText1:SetLayer(6)
			CB.AbiText1:SetFontColor(1,1,1)
		end
		-- end sub

		CreateUI(LTCB)
		CreateUI(LFCB)
		CreateUI(LGCB)
		CreateUI(LPCB)
	end
end, "LargeCastBar", "InititalSetup"})

table.insert(Event.System.Update.Begin, {function()
	local now = Inspect.Time.Real()
	if (now - LastUpdate) > REFRESH then LastUpdate = now else return end

	if not SetSizeDone then
		SetSize(LTCB)
		SetSize(LFCB)
		SetSize(LGCB)
		SetSize(LPCB)
		SetSizeDone = true
	end

	-- sub
	local function UpdateSub(CB)
		if CB and CB.unit and CB.begin and CB.duration then
			local multi = (now - CB.begin) / CB.duration
			if multi > 0 then
				if multi > 1 then multi = 1 end
				if not CB.channeled then multi = 1 - multi end
				local w = math.ceil(CB.w*multi)
				CB.Mask1:SetWidth(w)
				if CB.w-w < CB.h then
					local f = 1-(1-((CB.w-w)/CB.h)^2)
					CB.FrashTexture1:SetAlpha(f)
					CB.FrashTexture1:SetWidth(CB.h*f)
				else
					CB.FrashTexture1:SetAlpha(1)
					CB.FrashTexture1:SetWidth(CB.h)
				end
			else
				CB.Frame1:SetVisible(false)
				CB.unit = nil
				CB.lock = true
			end
		end
	end
	-- end sub

	UpdateSub(LTCB)
	UpdateSub(LFCB)
	UpdateSub(LGCB)
	UpdateSub(LPCB)
end, "LargeCastBar", "Update"})

local function OnCastbar(val)
	for k, v in pairs(val) do
		if v then
			-- sub
			local function CastbarSub(CB)
				if not CB then return end

				local id = Inspect.Unit.Lookup(CB.lookup)
				detail = Inspect.Unit.Castbar(k) or false
				if id == k and detail then
					local abiName = detail.abilityName or ""
					if detail.channeled then
						CB.BarColorFrame1:SetBackgroundColor(0,.5,0,.5)
						CB.channeled = true
						CB.Mask1:SetWidth(0)
					elseif detail.uninterruptible then
						CB.BarColorFrame1:SetBackgroundColor(1,.8,0,.5)
						CB.channeled = false
						CB.Mask1:SetWidth(CB.w)
					else
						CB.BarColorFrame1:SetBackgroundColor(0,.6,.9,.5)
						CB.channeled = false
						CB.Mask1:SetWidth(CB.w)
					end
					CB.AbiText1:SetText(abiName)
					CB.AbiTextShadow1:SetText(abiName)
					CB.AbiTextShadow2:SetText(abiName)
					CB.FrashTexture1:SetAlpha(0)
					CB.Frame1:SetVisible(true)
					CB.begin = Inspect.Time.Real()
					CB.duration = detail.duration
					CB.unit = k
					return(true)
				end
			end
			-- end sub

			CastbarSub(LTCB)
			CastbarSub(LFCB)
			CastbarSub(LGCB)
			CastbarSub(LPCB)
		else
			-- sub
			local function SetDeactive(CB)
				if not CB then return end
				if k == CB.unit then
					CB.Frame1:SetVisible(false)
					CB.unit = nil
					CB.lock = true
				end
			end
			-- end sub

			SetDeactive(LTCB)
			SetDeactive(LFCB)
			SetDeactive(LGCB)
			SetDeactive(LPCB)
		end
	end
end
table.insert(Event.Unit.Castbar, {OnCastbar, "LargeCastBar", "OnCastbar"})

table.insert(Event.Ability.New.Target, {function (val)
	local t = Inspect.Unit.Lookup(LTCB.lookup)
	if t then
		OnCastbar({[t]=true})
		if LGCB then
			local g = Inspect.Unit.Lookup(LGCB.lookup)
			if g then
				OnCastbar({[g]=true})
			end
		end
	else
		--sub
		local function SetDeactivate(CB)
			if not CB then return end
			CB.Frame1:SetVisible(false)
			CB.unit = nil
			CB.lock = true
		end
		-- end sub

		SetDeactivate(LTCB)
		SetDeactivate(LGCB)
	end
end, "LargeCastBar", "OnTarget"})

table.insert(Command.Slash.Register("lcb"), {function(cmd)
	cmd = cmd:lower()
	local arg = {}
	local i = 1
	for v in string.gmatch(cmd, "[^%s]+") do
		arg[i] = v
		i = i + 1
	end

	-- sub
	local function PrintEnable(command)
		Pr("This bar is Disable. Can enable type \"/lcb "..command.."\" and reboot.")
	end

	local function SetH(CB, command)
		if CB then
			if tonumber(arg[2]) then
				CB.h = tonumber(arg[2])
				SetSize(CB)
				CB.Frame1:SetVisible(true)
			else
				Pr("Height = "..CB.h)
			end
		else
			PrintEnable(command)
		end
	end

	local function SetW(CB, command)
		if CB then
			if tonumber(arg[2]) then
				CB.w = tonumber(arg[2])
				SetSize(CB)
				CB.Frame1:SetVisible(true)
			else
				Pr("Width = "..CB.w)
			end
		else
			PrintEnable(command)
		end
	end

	local function PrintReflect(name, b)
		local str = "disable"
		if b then str = "enable" end
		Pr(name.." is "..str..". Reflection will after reboot.")
	end

	local function SetCBAlpha(CB)
		if tonumber(arg[2]) then
			local a = tonumber(arg[2])
			CB.Frame1:SetAlpha(a)
			CB.a = a
		end
		Pr(CB.title.." alpha is "..CB.a..".")
	end
	-- end sub

	if arg[1] == "th" then
		SetH(LTCB, "t")
	elseif arg[1] == "tw" then
		SetW(LTCB, "t")
	elseif arg[1] == "fh" then
		SetH(LFCB, "f")
	elseif arg[1] == "fw" then
		SetW(LFCB, "f")
	elseif arg[1] == "tth" then
		SetH(LGCB, "tt")
	elseif arg[1] == "ttw" then
		SetW(LGCB, "tt")
	elseif arg[1] == "ph" then
		SetH(LPCB, "p")
	elseif arg[1] == "pw" then
		SetW(LPCB, "p")
	elseif arg[1] == "t" then
		TBarEnable = not TBarEnable
		PrintReflect("LCB Target", TBarEnable)
	elseif arg[1] == "f" then
		FBarEnable = not FBarEnable
		PrintReflect("LCB Focus", FBarEnable)
	elseif arg[1] == "tt" then
		GBarEnable = not GBarEnable
		PrintReflect("LCB TargetTarget", GBarEnable)
	elseif arg[1] == "p" then
		PBarEnable = not PBarEnable
		PrintReflect("LCB Castbar", PBarEnable)
	elseif arg[1] == "ta" then
		SetCBAlpha(LTCB)
	elseif arg[1] == "fa" then
		SetCBAlpha(LFCB)
	elseif arg[1] == "tta" then
		SetCBAlpha(LGCB)
	elseif arg[1] == "pa" then
		SetCBAlpha(LPCB)
	elseif arg[1] == "set" then
		Pr("set mode: Right click turn off bar visible.")
		-- sub
		local function Set(CB)
			if not CB then return end
			CB.lock = false
			CB.Frame1:SetVisible(true)
			CB.AbiText1:SetText(CB.title)
			CB.AbiTextShadow1:SetText(CB.title)
			CB.AbiTextShadow2:SetText(CB.title)
		end
		-- end sub

		Set(LTCB)
		Set(LFCB)
		Set(LGCB)
		Set(LPCB)
	elseif arg[1] == "reset" then

		-- sub
		local function Reset(CB)
			if not CB then return end
			CB.h = math.ceil(CB.parent:GetHeight()*.12)
			CB.w = math.ceil(CB.parent:GetWidth()*.65)
			CB.x = math.ceil(CB.parent:GetLeft()-CB.parent:GetWidth()*.04)
			CB.y = math.ceil(CB.parent:GetTop()+CB.parent:GetHeight()*.06)
			CB.a = 1
		end
		-- end sub

		Reset(LTCB)
		Reset(LFCB)
		Reset(LGCB)
		if LPCB then
			LPCB.h = LPCB.parent:GetHeight() or 40
			LPCB.w = LPCB.parent:GetWidth() or 360
			LPCB.x = LPCB.parent:GetLeft() or 40
			LPCB.y = LPCB.parent:GetTop() or 40
			LPCB.h = math.ceil(LPCB.h)
            LPCB.w = math.ceil(LPCB.w)
            LPCB.x = math.ceil(LPCB.x)
            LPCB.y = math.ceil(LPCB.y)
			LPCB.a = 1
		end

		SetSize(LTCB)
		SetSize(LFCB)
		SetSize(LGCB)
		SetSize(LPCB)
	else
		Pr("&#047;lcb th #&#166;tw #&#166;fh #&#166;fw #&#166;tth #&#166;ttw #&#166;ph #&#166;pw #&#166;t&#166;f&#166;tt&#166;p&#166;ta #&#166;fa #&#166;tta #&#166;pa #&#166;set&#166;reset")
	end
end, "LargeCastBar", "SlashCommand"})

table.insert(Event.Addon.SavedVariables.Save.Begin, {function (addon)
	if addon == "LargeCastBar" then
		if LTCB then
			L_CB.TargetBarHeight	= LTCB.h
			L_CB.TargetBarWidth		= LTCB.w
			L_CB.TargetBarX			= LTCB.x
			L_CB.TargetBarY			= LTCB.y
			L_CB.TargetBarAlpha		= LTCB.a
		end

		if LFCB then
			L_CB.FocusBarHeight		= LFCB.h
			L_CB.FocusBarWidth		= LFCB.w
			L_CB.FocusBarX			= LFCB.x
			L_CB.FocusBarY			= LFCB.y
			L_CB.FocusBarAlpha		= LFCB.a
		end

		if LGCB then
			L_CB.TTBarHeight		= LGCB.h
			L_CB.TTBarWidth			= LGCB.w
			L_CB.TTBarX				= LGCB.x
			L_CB.TTBarY				= LGCB.y
			L_CB.TTBarAlpha			= LGCB.a
		end

		if LPCB then
			L_CB.PlayerBarHeight	= LPCB.h
			L_CB.PlayerBarWidth		= LPCB.w
			L_CB.PlayerBarX			= LPCB.x
			L_CB.PlayerBarY			= LPCB.y
			L_CB.PlayerBarAlpha		= LPCB.a
		end

		L_CB.TargetBarEnable		= TBarEnable
		L_CB.FocusBarEnable			= FBarEnable
		L_CB.TTBarEnable			= GBarEnable
		L_CB.PlayerBarEnable		= PBarEnable
	end
end, "LargeCastBar", "SavedVariablesSaveBegin"})
